#include <iostream>
#include <string>
#include <ctime>
#include "Integer.h"
#include "factor.hpp"

int main ( int argc, char *argv[] ) {
   Integer n , factor ;
   std::string str;
   if ( argc != 2 ) { 
      std::cout << "Entrez n : ";
      std::cin >> str;
      n = str.c_str();
   }
   else n = argv[ 1 ] ;
   std::cout << "Number to factor : " << n << std::endl ; 
   std::cout << "Factors found : " << std::flush ;
   clock_t start = clock();
   if ( isprime( n ) ) { 
      std::cout << n << " is prime !" << std::endl ; 
      goto fin ; 
   }
   while ( !isprime( n ) ) { 
      factor = get_factor( n ) ; 
      if( factor == 0 ) { 
		  std::cout << " rho en \202chec " << std::endl ; 
          goto fin ;
      }
      std::cout << factor << " x " << std::flush ; 
      n /= factor ; 
   } 
   std::cout << n << std::endl ;
   fin: std::cout << "  en " << double(clock()-start)/CLOCKS_PER_SEC << " s" << std::endl;
   return 0 ;
}
