// main.cpp

#include <ctime>
#include "biginteger.hpp"

int main(int argc, char *argv[]) {
    BigInteger n;
    if ( argc != 2 ) { 
        std::cout << "Entrez n : ";
        std::cin >> n;
    }
    else n = argv[1];
    clock_t start = clock();
    std::cout << "Factorisation de : " << n << std::endl;
    std::vector<BigInteger> prems = fctpbi(n);
    for(unsigned int i = 0; i < prems.size()-1; i++) std::cout << prems[i] << " x ";
    std::cout << prems[prems.size()-1] << std::endl;;
    std::cout << "  en " << double(clock()-start)/CLOCKS_PER_SEC << " s" << std::endl;
    return 0;
}